/*------------------------------------------------------------------------------
-- This file is a part of the QLop Software
-- Copyright (C) 2015, Plasma Physics Laboratory - CNRS
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
-------------------------------------------------------------------------------*/
/*-- Author : Alexis Jeandet
-- Mail : alexis.jeandet@member.fsf.org
----------------------------------------------------------------------------*/

#ifndef QLOPPLOTS_H
#define QLOPPLOTS_H

#include <QObject>
#include <QWidget>
#include <qlopservice.h>
#include <SocExplorerPlot.h>
#include <QList>
#include <QHash>
#include <toolbarcontainer.h>

class QLopPlots: public QLopService
{
    Q_OBJECT
private:
    static QLopPlots* _self;
    static SocExplorerPlot* m_LastPlot;
    static QHash<int,SocExplorerPlot*>* m_plots;
    static QDockWidget* m_gui;
    static toolBarContainer* m_DocContainer;
    QLopPlots(bool noGUI=false,QObject *parent = 0);
    ~QLopPlots();
    static int getPlotID();

public:
    static void init(bool noGUI=false,QObject *parent = 0);
    static QLopPlots *self();
    static SocExplorerPlot* getPlot(int plotID=-1);
    static int addPlot();
    static bool removePlot(int plotID);
    // QLopService methodes
    QDockWidget* getGUI();
    const QString& serviceName();
public slots:
    SocExplorerPlot* get_plot(int plotID);
    int add_plot();
    bool remove_plot(int plotID);
public:
};

#endif // QLOPPLOTS_H
